3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
39 OK_TO_SKIP_PRE_REBASE=
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
49 dotest="$GIT_DIR"/rebase-merge
52 diffstat=$(git config --bool rebase.stat)
56 allow_rerere_autoupdate=
59 test -n "$prev_head" || die "prev_head must be defined"
60 test -d "$dotest" || die "$dotest directory does not exist"
62 unmerged=$(git ls-files -u)
63 if test -n "$unmerged"
65 echo "You still have unmerged paths in your index"
66 echo "did you forget to use git add?"
70 cmt=`cat "$dotest/current"`
71 if ! git diff-index --quiet --ignore-submodules HEAD --
73 if ! git commit --no-verify -C "$cmt"
75 echo "Commit failed, please do not call \"git commit\""
76 echo "directly, but instead do one of the following: "
79 if test -z "$GIT_QUIET"
81 printf "Committed: %0${prec}d " $msgnum
83 echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
85 if test -z "$GIT_QUIET"
87 printf "Already applied: %0${prec}d " $msgnum
90 test -z "$GIT_QUIET" &&
91 GIT_PAGER='' git log --format=%s -1 "$cmt"
93 prev_head=`git rev-parse HEAD^0`
94 # save the resulting commit so we can read-tree on it later
95 echo "$prev_head" > "$dotest/prev_head"
97 # onto the next patch:
98 msgnum=$(($msgnum + 1))
99 echo "$msgnum" >"$dotest/msgnum"
103 cmt="$(cat "$dotest/cmt.$1")"
104 echo "$cmt" > "$dotest/current"
105 hd=$(git rev-parse --verify HEAD)
106 cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
107 msgnum=$(cat "$dotest/msgnum")
108 end=$(cat "$dotest/end")
109 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
110 eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
111 export GITHEAD_$cmt GITHEAD_$hd
112 if test -n "$GIT_QUIET"
114 GIT_MERGE_VERBOSITY=1 && export GIT_MERGE_VERBOSITY
116 eval 'git-merge-$strategy' $strategy_opts '"$cmt^" -- "$hd" "$cmt"'
120 unset GITHEAD_$cmt GITHEAD_$hd
124 git rerere $allow_rerere_autoupdate
128 echo "Strategy: $rv $strategy failed, try another" 1>&2
132 die "Unknown exit code ($rv) from command:" \
133 "git-merge-$strategy $cmt^ -- HEAD $cmt"
138 move_to_original_branch () {
139 test -z "$head_name" &&
140 head_name="$(cat "$dotest"/head-name)" &&
141 onto="$(cat "$dotest"/onto)" &&
142 orig_head="$(cat "$dotest"/orig-head)"
145 message="rebase finished: $head_name onto $onto"
146 git update-ref -m "$message" \
147 $head_name $(git rev-parse HEAD) $orig_head &&
148 git symbolic-ref HEAD $head_name ||
149 die "Could not move back to $head_name"
155 move_to_original_branch
156 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
157 if test -x "$GIT_DIR"/hooks/post-rewrite &&
158 test -s "$dotest"/rewritten; then
159 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
170 interactive_rebase=explicit
173 -p|--preserve-merges)
174 interactive_rebase=implied
180 if [ "$interactive_rebase" = implied ]; then
185 test -n "$interactive_rebase" || test -f "$dotest"/interactive
188 run_pre_rebase_hook () {
189 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
190 test -x "$GIT_DIR/hooks/pre-rebase"
192 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
193 die "The pre-rebase hook refused to rebase."
197 test -f "$GIT_DIR"/rebase-apply/applying &&
198 die 'It looks like git-am is in progress. Cannot rebase.'
200 is_interactive "$@" && exec git-rebase--interactive "$@"
206 OK_TO_SKIP_PRE_REBASE=yes
209 OK_TO_SKIP_PRE_REBASE=
212 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
213 die "No rebase in progress?"
215 git update-index --ignore-submodules --refresh &&
216 git diff-files --quiet --ignore-submodules || {
217 echo "You must edit all merge conflicts and then"
218 echo "mark them as resolved using git add"
223 prev_head=$(cat "$dotest/prev_head")
224 end=$(cat "$dotest/end")
225 msgnum=$(cat "$dotest/msgnum")
226 onto=$(cat "$dotest/onto")
227 GIT_QUIET=$(cat "$dotest/quiet")
229 while test "$msgnum" -le "$end"
237 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
238 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
239 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
240 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
241 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
242 move_to_original_branch
246 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
247 die "No rebase in progress?"
249 git reset --hard HEAD || exit $?
253 prev_head=$(cat "$dotest/prev_head")
254 end=$(cat "$dotest/end")
255 msgnum=$(cat "$dotest/msgnum")
256 msgnum=$(($msgnum + 1))
257 onto=$(cat "$dotest/onto")
258 GIT_QUIET=$(cat "$dotest/quiet")
259 while test "$msgnum" -le "$end"
267 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
268 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
269 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
270 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
271 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
272 move_to_original_branch
276 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
277 die "No rebase in progress?"
281 test -d "$dotest" || dotest="$GIT_DIR"/rebase-apply
283 head_name="$(cat "$dotest"/head-name)" &&
286 git symbolic-ref HEAD $head_name ||
287 die "Could not move back to $head_name"
290 git reset --hard $(cat "$dotest/orig-head")
295 test 2 -le "$#" || usage
299 -M|-m|--m|--me|--mer|--merg|--merge)
302 -X*|--strategy-option*)
304 1,-X|1,--strategy-option)
306 *,-X|*,--strategy-option)
309 *,--strategy-option=*)
310 newopt="$(expr " $1" : ' --strategy-option=\(.*\)')" ;;
312 newopt="$(expr " $1" : ' -X\(.*\)')" ;;
316 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$newopt")"
319 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
320 --strateg=*|--strategy=*|\
321 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
324 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
346 git_am_opt="$git_am_opt -q"
351 git_am_opt="$git_am_opt $1"
353 --whitespace=fix|--whitespace=strip)
359 git_am_opt="$git_am_opt $1"
361 --committer-date-is-author-date|--ignore-date)
362 git_am_opt="$git_am_opt $1"
366 git_am_opt="$git_am_opt $1"
371 -f|--f|--fo|--for|--forc|--force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase|--no-ff)
374 --rerere-autoupdate|--no-rerere-autoupdate)
375 allow_rerere_autoupdate="$1"
386 test $# -gt 2 && usage
388 if test $# -eq 0 && test -z "$rebase_root"
390 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
391 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
392 die 'A rebase is in progress, try --continue, --skip or --abort.'
395 # Make sure we do not have $GIT_DIR/rebase-apply
396 if test -z "$do_merge"
398 if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
400 rmdir "$GIT_DIR"/rebase-apply
403 It seems that I cannot create a rebase-apply directory, and
404 I wonder if you are in the middle of patch application or another
405 rebase. If that is not the case, please
406 rm -fr '"$GIT_DIR"'/rebase-apply
407 and run me again. I am stopping in case you still have something
414 die "previous rebase directory $dotest still exists." \
415 'Try git rebase (--continue | --abort | --skip)'
419 require_clean_work_tree "rebase" "Please commit or stash them."
421 if test -z "$rebase_root"
423 # The upstream head must be given. Make sure it is valid.
426 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
427 die "invalid upstream $upstream_name"
429 upstream_arg="$upstream_name"
431 test -z "$newbase" && die "--root must be used with --onto"
435 upstream_arg="$root_flag"
438 # Make sure the branch to rebase onto is valid.
439 onto_name=${newbase-"$upstream_name"}
442 if left=${onto_name%...*} right=${onto_name#*...} &&
443 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
447 die "$onto_name: there are more than one merge bases"
450 die "$onto_name: there is no merge base"
454 die "$onto_name: there is no merge base"
458 onto=$(git rev-parse --verify "${onto_name}^0") || exit
462 # If a hook exists, give it a chance to interrupt
463 run_pre_rebase_hook "$upstream_arg" "$@"
465 # If the branch to rebase is given, that is the branch we will rebase
466 # $branch_name -- branch being rebased, or HEAD (already detached)
467 # $orig_head -- commit object name of tip of the branch before rebasing
468 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
472 # Is it "rebase other $branchname" or "rebase other $commit"?
476 if git show-ref --verify --quiet -- "refs/heads/$1" &&
477 branch=$(git rev-parse -q --verify "refs/heads/$1")
479 head_name="refs/heads/$1"
480 elif branch=$(git rev-parse -q --verify "$1")
482 head_name="detached HEAD"
488 # Do not need to switch branches, we are already on it.
489 if branch_name=`git symbolic-ref -q HEAD`
491 head_name=$branch_name
492 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
494 head_name="detached HEAD"
495 branch_name=HEAD ;# detached
497 branch=$(git rev-parse --verify "${branch_name}^0") || exit
502 # Now we are rebasing commits $upstream..$branch (or with --root,
503 # everything leading up to $branch) on top of $onto
505 # Check if we are already based on $onto with linear history,
506 # but this should be done only when upstream and onto are the same.
507 mb=$(git merge-base "$onto" "$branch")
508 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
510 ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
512 if test -z "$force_rebase"
514 # Lazily switch to the target branch if needed...
515 test -z "$switch_to" || git checkout "$switch_to"
516 say "Current branch $branch_name is up to date."
519 say "Current branch $branch_name is up to date, rebase forced."
523 # Detach HEAD and reset the tree
524 say "First, rewinding head to replay your work on top of it..."
525 git checkout -q "$onto^0" || die "could not detach HEAD"
526 git update-ref ORIG_HEAD $branch
528 if test -n "$diffstat"
530 if test -n "$verbose"
532 echo "Changes from $mb to $onto:"
534 # We want color (if set), but no pager
535 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
538 # If the $onto is a proper descendant of the tip of the branch, then
539 # we just fast-forwarded.
540 if test "$mb" = "$branch"
542 say "Fast-forwarded $branch_name to $onto_name."
543 move_to_original_branch
547 if test -n "$rebase_root"
549 revisions="$onto..$orig_head"
551 revisions="$upstream..$orig_head"
554 if test -z "$do_merge"
556 git format-patch -k --stdout --full-index --ignore-if-in-upstream \
557 --src-prefix=a/ --dst-prefix=b/ \
558 --no-renames $root_flag "$revisions" |
559 git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
560 move_to_original_branch
562 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
563 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
564 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
565 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
566 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
570 # start doing a rebase with git-merge
571 # this is rename-aware if the recursive (default) strategy is used
574 echo "$onto" > "$dotest/onto"
575 echo "$onto_name" > "$dotest/onto_name"
577 echo "$prev_head" > "$dotest/prev_head"
578 echo "$orig_head" > "$dotest/orig-head"
579 echo "$head_name" > "$dotest/head-name"
580 echo "$GIT_QUIET" > "$dotest/quiet"
583 for cmt in `git rev-list --reverse --no-merges "$revisions"`
585 msgnum=$(($msgnum + 1))
586 echo "$cmt" > "$dotest/cmt.$msgnum"
589 echo 1 >"$dotest/msgnum"
590 echo $msgnum >"$dotest/end"
595 while test "$msgnum" -le "$end"